#include <stdexcept>


class TimeoutException
    : public std::runtime_error 
{
  public:

    TimeoutException() : std::runtime_error("Timeout") {;}

    TimeoutException(const char* message)
        : std::runtime_error(message) {
    }

    TimeoutException(const std::string& message)
        : std::runtime_error(message) {
    }
};