#pragma once

#include "fragment_dataformat.h"
#include <cstdint>

#define FULL_EVENT_HEADER_MARKER 0xaa1234aa

typedef struct FullEvent {
    uint32_t startOfHeaderMarker = FULL_EVENT_HEADER_MARKER;
    uint32_t headerSize;
    uint32_t eventSize;
    uint32_t runNumber;

    Fragment *fragmentsArray;

}FullEvent;